package fire;

// Fire model for SFI Graduate Workshop in Computational Economics
// (c)2003 Laszlo Gulyas, Scott Moser, Jason Woodard

public class MovingRule {

    double[] adjustments;
    double[] weights;

    public MovingRule(int dim) {
        adjustments = new double[dim];
        for (int i = 0; i < dim; i++) {
            adjustments[i] = 0;
        }
        weights = new double[dim];
    }

    public MovingRule(double[] adj, double[] w) {
        adjustments = new double[adj.length];
        for (int i = 0; i < adj.length; i++) {
            adjustments[i] = adj[i];
        }

        weights = new double[w.length];
        for (int i = 0; i < w.length; i++) {
            weights[i] = w[i];
        }
    }

    public DirVector getDirection(DirVector[] perception) {
        DirVector v = DirVector.NULL;

        for (int i = 0; i < perception.length; i++) {
            DirVector w = perception[i];
            w = w.rotate(adjustments[i]);
            w = w.scale(weights[i]);
            v = v.add(w);
        }

        return v;
    }
}